function Create(self)

	self.speedThreshold = 20;

	self.strengthThreshold = 4;

	self.effectSpeed = 4;

	local pos = Vector();
	local trace = Vector(self.Vel.X, self.Vel.Y):RadRotate(math.pi) * TimerMan.DeltaTimeSecs * 20;
	if SceneMan:CastObstacleRay(self.Pos, trace, pos, Vector(), 0, self.Team, 0, 5) >= 0 then
		--Check that the position is actually strong enough to cause dissipation.
		trace = SceneMan:ShortestDistance(self.Pos, pos, true);
		local strength = SceneMan:CastStrengthRay(self.Pos, trace, self.strengthThreshold, Vector(), 0, 0, true);
		local mo = SceneMan:CastMORay(self.Pos, trace, 0, self.Team, 0, true, 5);
		if strength or (mo ~= 255 and mo ~= 0) then
			local effect = CreateAEmitter("4V.rte/Vulcan MG Blast");
			effect.Pos = pos + Vector(self.Vel.X, self.Vel.Y):RadRotate(math.pi):SetMagnitude(3);
			effect.Vel = Vector(self.Vel.X, self.Vel.Y):RadRotate(math.pi):SetMagnitude(self.effectSpeed);
			MovableMan:AddParticle(effect);
			effect:GibThis();
			self.ToDelete = true;
		end
	end
end

function Update(self)
	if not self.ToDelete then
		if self.Vel.Magnitude >= self.speedThreshold then

			local pos = Vector();
			local trace = Vector(self.Vel.X, self.Vel.Y) * TimerMan.DeltaTimeSecs * 20;
			if SceneMan:CastObstacleRay(self.Pos, trace, pos, Vector(), 0, self.Team, 0, 5) >= 0 then
				--Check that the position is actually strong enough to cause dissipation.
				trace = SceneMan:ShortestDistance(self.Pos, pos, true);
				local strength = SceneMan:CastStrengthRay(self.Pos, trace, self.strengthThreshold, Vector(), 0, 0, true);
				local mo = SceneMan:CastMORay(self.Pos, trace, 0, self.Team, 0, true, 5);
				if strength or (mo ~= 255 and mo ~= 0) then
					local effect = CreateAEmitter("4V.rte/Vulcan MG Blast");
					effect.Pos = pos + Vector(self.Vel.X, self.Vel.Y):RadRotate(math.pi):SetMagnitude(3);
					effect.Vel = Vector(self.Vel.X, self.Vel.Y):RadRotate(math.pi):SetMagnitude(self.effectSpeed);
					MovableMan:AddParticle(effect);
					effect:GibThis();

					self.ToDelete = true;
				end
			end
		end

		local Effect
		local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel

		local trailLength = math.floor(Offset.Magnitude+0.5)
		for i = 1, trailLength, 5 do
			Effect = CreateMOSParticle("Vulcan Smoke Trail " .. math.random(3), "4V.rte")
			if Effect then
				Effect.Pos = self.Pos - Offset * (i/trailLength) + Vector(RangeRand(-1, 1), RangeRand(-1, 1))
				Effect.Vel = self.Vel * RangeRand(0.6, 0.9)
				MovableMan:AddParticle(Effect)
			end
		end
	end
end

function Destroy(self)

end