function Create(self)

	self.searchRange = RangeRand(0.75, 1.25)*200;
	self.target = nil;

	self.lifeTimer = Timer();
	self.life = 3000+math.random(1000);

	self.searchTimer = Timer();
	self.adjustTimer = Timer();
	self.turnAmount = 100;
end

function Update(self)

	if self.target and MovableMan:IsActor(self.target) then

		local dist = SceneMan:ShortestDistance(self.Pos,self.target.Pos,SceneMan.SceneWrapsX); -- assuming a target is already assigned
		local adjustedTurnAmount = self.turnAmount*(self.adjustTimer.ElapsedSimTimeMS/1000); -- adjusting the turn amount based on MS time in between frames
		local adjustVector = Vector(adjustedTurnAmount,0):RadRotate(dist.AbsRadAngle)
		--local oldSpeed = self.Vel.Magnitude;

		self.Vel = Vector( self.Vel.X + adjustVector.X, self.Vel.Y + adjustVector.Y ):SetMagnitude(25);
		self.adjustTimer:Reset();

	else
		--self.Vel = Vector(self.Vel.X,self.Vel.Y):SetMagnitude(25);

		if self.searchTimer:IsPastSimMS(20) then
			local dist = Vector(self.searchRange+1,0);
			for actor in MovableMan.Actors do
				if actor.Team ~= self.Team then
					local curdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX);
					if curdist.Magnitude < dist.Magnitude and SceneMan:CastStrengthRay(self.Pos,curdist:SetMagnitude(curdist.Magnitude-actor.Radius),20,Vector(0,0),5,0,SceneMan.SceneWrapsX) == false then
					self.target = actor;
						dist = curdist;
					end
				end
			end

			self.searchTimer:Reset();
		end
	end

	if self.lifeTimer:IsPastSimMS(self.life) then

		self.ToDelete = true;
	end

	if self.ToDelete == true then

		if math.random() >= 0.50 then

			part = CreateMOSParticle("Tiny Smoke Ball 1");
			part.Pos = self.Pos;
			part.Vel = self.Vel * RangeRand(0, 0.5);
			MovableMan:AddParticle(part);
		end
	end
end

function Destroy(self)

end